ConRO.Monk = {};
ConRO.Monk.CheckTalents = function()
end
local ConRO_Monk, ids = ...;

function ConRO:EnableRotationModule(mode)
	local _Player_Level = UnitLevel("player");

	mode = mode or 1;
	self.ModuleOnEnable = ConRO.Monk.CheckTalents;
	self.ModuleOnEnable = ConRO.Monk.CheckPvPTalents;	
	if _Player_Level <= 9 then
		self.Description = "Monk [No Specialization Under 10]";
		self.ToggleHealer();
	end;
	if mode == 1 then
		self.Description = "Monk [Brewmaster - Tank]";
		self.NextSpell = ConRO.Monk.Brewmaster;
		self.ToggleDamage();
		self.BlockAoE();		
	end;
	if mode == 2 then
		self.Description = "Monk [Mistweaver - Healer]";
		self.NextSpell = ConRO.Monk.Mistweaver;
		self.ToggleHealer();
	end;
	if mode == 3 then
		self.Description = "Monk [Windwalker - Melee]";
		self.NextSpell = ConRO.Monk.Windwalker;
		self.ToggleDamage();
	end;
	self:RegisterEvent('UNIT_SPELLCAST_SUCCEEDED');
	self.lastSpellId = 0;
end

function ConRO:EnableDefenseModule(mode)
	mode = mode or 1;
	self.ModuleOnEnable = ConRO.Monk.CheckTalents;
	self.ModuleOnEnable = ConRO.Monk.CheckPvPTalents;	
	if mode == 1 then
		self.NextDef = ConRO.Monk.BrewmasterDef;
	end;
	if mode == 2 then
		self.NextDef = ConRO.Monk.MistweaverDef;
	end;
	if mode == 3 then
		self.NextDef = ConRO.Monk.WindwalkerDef;
	end;
end

function ConRO:UNIT_SPELLCAST_SUCCEEDED(event, unitID, lineID, spellID)
	if unitID == 'player' then
		self.lastSpellId = spellID;
	end
end

function ConRO.Monk.Brewmaster(_, timeShift, currentSpell, gcd, tChosen, pvpChosen)
--Info
	local _Player_Level																	= UnitLevel("player");
	local _is_PvP																		= UnitIsPVP('player');
	local _in_combat 																	= UnitAffectingCombat('player');
	local _is_moving 																	= ConRO:PlayerSpeed();
	
--Resources	
	local _Player_Percent_Health 														= ConRO:PercentHealth('player');
	local _Player_Health 																= UnitHealth('player');
	local _Energy 																		= UnitPower('player', Enum.PowerType.Energy);
	local _Energy_Max																		= UnitPowerMax('player', Enum.PowerType.Energy);

--Racials
	local _ArcaneTorrent_RDY															= ConRO:AbilityReady(ids.Racial.ArcaneTorrent, timeShift);
	
--Abilities
	local _BlackoutKick_RDY																= ConRO:AbilityReady(ids.Bm_Ability.BlackoutKick, timeShift);
		local _BlackoutCombo_BUFF															= ConRO:Aura(ids.Bm_Buff.BlackoutCombo, timeShift);
	local _BreathofFire_RDY																= ConRO:AbilityReady(ids.Bm_Ability.BreathofFire, timeShift);
	local _CelestialBrew_RDY															= ConRO:AbilityReady(ids.Bm_Ability.CelestialBrew, timeShift);
	local _InvokeNiuzaotheBlackOx_RDY													= ConRO:AbilityReady(ids.Bm_Ability.InvokeNiuzaotheBlackOx, timeShift);
	local _KegSmash_RDY																	= ConRO:AbilityReady(ids.Bm_Ability.KegSmash, timeShift);
		local _KegSmash_DEBUFF																= ConRO:TargetAura(ids.Bm_Debuff.KegSmash, timeShift);
	local _Provoke_RDY																	= ConRO:AbilityReady(ids.Bm_Ability.Provoke, timeShift);
	local _PurifyingBrew_RDY															= ConRO:AbilityReady(ids.Bm_Ability.PurifyingBrew, timeShift);	
		local _PurifyingBrew_CHARGES														= ConRO:SpellCharges(ids.Bm_Ability.PurifyingBrew);
	local _Roll_RDY																		= ConRO:AbilityReady(ids.Bm_Ability.Roll, timeShift);
	local _SpearHandStrike_RDY 															= ConRO:AbilityReady(ids.Bm_Ability.SpearHandStrike, timeShift);
	local _SpinningCraneKick_RDY														= ConRO:AbilityReady(ids.Bm_Ability.SpinningCraneKick, timeShift);
	local _TigerPalm_RDY																= ConRO:AbilityReady(ids.Bm_Ability.TigerPalm, timeShift);
	local _TouchofDeath_RDY																= ConRO:AbilityReady(ids.Bm_Ability.TouchofDeath, timeShift);
	
	local _BlackOxBrew_RDY																= ConRO:AbilityReady(ids.Bm_Talent.BlackOxBrew, timeShift);
	local _ChiBurst_RDY																	= ConRO:AbilityReady(ids.Bm_Talent.ChiBurst, timeShift);
	local _ChiTorpedo_RDY																= ConRO:AbilityReady(ids.Bm_Talent.ChiTorpedo, timeShift);
		local _ChiTorpedo_BUFF																= ConRO:Aura(ids.Bm_Buff.ChiTorpedo, timeShift);	
	local _ChiWave_RDY																	= ConRO:AbilityReady(ids.Bm_Talent.ChiWave, timeShift);
	local _ExplodingKeg_RDY																= ConRO:AbilityReady(ids.Bm_Talent.ExplodingKeg, timeShift);
	local _RushingJadeWind_RDY															= ConRO:AbilityReady(ids.Bm_Talent.RushingJadeWind, timeShift);
		local _RushingJadeWind_BUFF															= ConRO:Aura(ids.Bm_Buff.RushingJadeWind, timeShift);	
	local _TigersLust_RDY																= ConRO:AbilityReady(ids.Bm_Talent.TigersLust, timeShift);

	local _BonedustBrew_RDY																= ConRO:AbilityReady(ids.Covenant_Ability.BonedustBrew, timeShift);
		local _BonedustBrew_BUFF															= ConRO:Aura(ids.Covenant_Buff.BonedustBrew, timeShift);
	local _FaelineStomp_RDY																= ConRO:AbilityReady(ids.Covenant_Ability.FaelineStomp, timeShift);
		local _FaelineStomp_BUFF															= ConRO:Aura(ids.Covenant_Buff.FaelineStomp, timeShift);
	local _FallenOrder_RDY																= ConRO:AbilityReady(ids.Covenant_Ability.FallenOrder, timeShift);
		local _FallenOrder_BUFF																= ConRO:Aura(ids.Covenant_Buff.FallenOrder, timeShift);
	local _WeaponsofOrder_RDY															= ConRO:AbilityReady(ids.Covenant_Ability.WeaponsofOrder, timeShift);
		local _WeaponsofOrder_BUFF															= ConRO:Aura(ids.Covenant_Buff.WeaponsofOrder, timeShift);
		
--Conditions
	local _enemies_in_melee, _target_in_melee											= ConRO:Targets("Melee");
	local _Target_Percent_Health  														= ConRO:PercentHealth('target');
	local _Target_Health 																= UnitHealth('target');
	
--Indicators
	ConRO:AbilityInterrupt(ids.Bm_Ability.SpearHandStrike, _SpearHandStrike_RDY and ConRO:Interrupt());
	ConRO:AbilityPurge(ids.Racial.ArcaneTorrent, _ArcaneTorrent_RDY and _target_in_melee and ConRO:Purgable());
	ConRO:AbilityMovement(ids.Bm_Ability.Roll, _Roll_RDY and not tChosen[ids.Bm_Talent.ChiTorpedo]);
	ConRO:AbilityMovement(ids.Bm_Talent.ChiTorpedo, _ChiTorpedo_RDY and not _ChiTorpedo_BUFF);
	ConRO:AbilityMovement(ids.Bm_Talent.TigersLust, _TigersLust_RDY);
	
	ConRO:AbilityTaunt(ids.Bm_Ability.Provoke, _Provoke_RDY and (not ConRO:InRaid() or (ConRO:InRaid() and ConRO:TarYou())));

	ConRO:AbilityBurst(ids.Bm_Ability.InvokeNiuzaotheBlackOx, _InvokeNiuzaotheBlackOx_RDY and ConRO_BurstButton:IsVisible());
	ConRO:AbilityBurst(ids.Covenant_Ability.WeaponsofOrder, _WeaponsofOrder_RDY and ConRO_BurstButton:IsVisible());
	ConRO:AbilityBurst(ids.Covenant_Ability.FallenOrder, _FallenOrder_RDY and ConRO_BurstButton:IsVisible());
	
--Rotations
	if _TouchofDeath_RDY then
		return ids.Bm_Ability.TouchofDeath;
	end

	if _InvokeNiuzaotheBlackOx_RDY and ConRO_FullButton:IsVisible() then
		return ids.Bm_Ability.InvokeNiuzaotheBlackOx;
	end

	if _WeaponsofOrder_RDY and ConRO_FullButton:IsVisible() then
		return ids.Covenant_Ability.WeaponsofOrder;
	end

	if _FallenOrder_RDY and ConRO_FullButton:IsVisible() then
		return ids.Covenant_Ability.FallenOrder;
	end	

	if _BonedustBrew_RDY then
		return ids.Covenant_Ability.BonedustBrew;
	end	
	
	if _BlackoutCombo_BUFF and tChosen[ids.Bm_Talent.BlackoutCombo] and ConRO.lastSpellId == ids.Bm_Ability.BlackoutKick then
		if _TigerPalm_RDY then
			return ids.Bm_Ability.TigerPalm;
		end
	end
	
	if _BlackOxBrew_RDY and _Energy <= 30 and not _CelestialBrew_RDY and not _PurifyingBrew_RDY then
		return ids.Bm_Talent.BlackOxBrew;
	end
	
	if _KegSmash_RDY then
		return ids.Bm_Ability.KegSmash;
	end

	if _FaelineStomp_RDY then
		return ids.Covenant_Ability.FaelineStomp;
	end
		
	if _BlackoutKick_RDY then
		return ids.Bm_Ability.BlackoutKick;
	end

	if _BreathofFire_RDY then
		return ids.Bm_Ability.BreathofFire;
	end

	if _enemies_in_melee >= 2 then
		if _ChiBurst_RDY then
			return ids.Bm_Talent.ChiBurst;
		end		

		if _ChiWave_RDY then
			return ids.Bm_Talent.ChiWave;
		end
	end

	if _RushingJadeWind_RDY and not _RushingJadeWind_BUFF then
		return ids.Bm_Talent.RushingJadeWind;
	end
	
	if _ExplodingKeg_RDY then
		return ids.Bm_Talent.ExplodingKeg;
	end	
	
	if _SpinningCraneKick_RDY and _Energy >= 65 and _enemies_in_melee >= 3 and _PurifyingBrew_CHARGES >= 1 and _CelestialBrew_RDY then
		return ids.Bm_Ability.SpinningCraneKick;
	end 

	if _TigerPalm_RDY and _Energy >= 65 and not tChosen[ids.Bm_Talent.BlackoutCombo] then
		return ids.Bm_Ability.TigerPalm;
	end 

	if _ChiBurst_RDY then
		return ids.Bm_Talent.ChiBurst;
	end		

	if _ChiWave_RDY then
		return ids.Bm_Talent.ChiWave;
	end
return nil;
end

function ConRO.Monk.BrewmasterDef(_, timeShift, currentSpell, gcd, tChosen, pvpChosen)
--Info
	local _Player_Level																	= UnitLevel("player");
	local _is_PvP																		= UnitIsPVP('player');
	local _in_combat 																	= UnitAffectingCombat('player');
	local _is_moving 																	= ConRO:PlayerSpeed();
	
--Resources	
	local _Player_Percent_Health 														= ConRO:PercentHealth('player');
	local _Energy 																		= UnitPower('player', Enum.PowerType.Energy);
	local _Energy_Max																		= UnitPowerMax('player', Enum.PowerType.Energy);

--Abilities
	local _CelestialBrew_RDY															= ConRO:AbilityReady(ids.Bm_Ability.CelestialBrew, timeShift);
	local _ExpelHarm_RDY																= ConRO:AbilityReady(ids.Bm_Ability.ExpelHarm, timeShift);		
	local _FortifyingBrew_RDY															= ConRO:AbilityReady(ids.Bm_Ability.FortifyingBrew, timeShift);
	local _PurifyingBrew_RDY															= ConRO:AbilityReady(ids.Bm_Ability.PurifyingBrew, timeShift);
		local _PurifiedChi_BUFF 															= ConRO:Aura(ids.Bm_Buff.PurifiedChi, timeShift);
		local _PurifyingBrew_CHARGES														= ConRO:SpellCharges(ids.Bm_Ability.PurifyingBrew);
		local _HighStagger_DEBUFF															= ConRO:Aura(ids.Bm_Debuff.HighStagger, timeShift, 'HARMFUL');
		local _MediumStagger_DEBUFF															= ConRO:Aura(ids.Bm_Debuff.MediumStagger, timeShift, 'HARMFUL');	
	local _ZenMeditation_RDY															= ConRO:AbilityReady(ids.Bm_Ability.ZenMeditation, timeShift);	

	local _DampenHarm_RDY																= ConRO:AbilityReady(ids.Bm_Talent.DampenHarm, timeShift);
	local _HealingElixir_RDY															= ConRO:AbilityReady(ids.Bm_Talent.HealingElixir, timeShift);	
	
	local _Fleshcraft_RDY																= ConRO:AbilityReady(ids.Covenant_Ability.Fleshcraft, timeShift);
	
--Indicators
	
--Rotations
	if _CelestialBrew_RDY and _PurifiedChi_BUFF then
		return ids.Bm_Ability.CelestialBrew;
	end

	if _PurifyingBrew_RDY and ((_PurifyingBrew_CHARGES >= 1 and _HighStagger_DEBUFF) or (_MediumStagger_DEBUFF and (_PurifyingBrew_CHARGES >= 2 or _Player_Percent_Health <= 50))) then
		return ids.Bm_Ability.PurifyingBrew;
	end
	
	if _HealingElixir_RDY and _Player_Percent_Health <= 80 then
		return ids.Bm_Talent.HealingElixir;
	end	
	
	if _ExpelHarm_RDY and _Player_Percent_Health <= 50 then
		return ids.Bm_Ability.ExpelHarm;
	end	

	if _Fleshcraft_RDY then
		return ids.Covenant_Ability.Fleshcraft;
	end
	
	if _DampenHarm_RDY then
		return ids.Bm_Talent.DampenHarm;
	end
	
	if _FortifyingBrew_RDY then
		return ids.Bm_Ability.FortifyingBrew;
	end	
	
return nil;
end

function ConRO.Monk.Mistweaver(_, timeShift, currentSpell, gcd, tChosen, pvpChosen)
--Info
	local _Player_Level																	= UnitLevel("player");
	local _is_PvP																		= UnitIsPVP('player');
	local _in_combat 																	= UnitAffectingCombat('player');
	local _is_moving 																	= ConRO:PlayerSpeed();
	
--Resources	
	local _Player_Percent_Health 														= ConRO:PercentHealth('player');
	local _Mana 																		= UnitPower('player', Enum.PowerType.Mana);
	local _Mana_Max																		= UnitPowerMax('player', Enum.PowerType.Mana);

--Racials
	local _ArcaneTorrent_RDY															= ConRO:AbilityReady(ids.Racial.ArcaneTorrent, timeShift);
	
--Abilities
	local _BlackoutKick_RDY 															= ConRO:AbilityReady(ids.Mw_Ability.BlackoutKick, timeShift);
	local _ChiTorpedo_RDY																= ConRO:AbilityReady(ids.Mw_Talent.ChiTorpedo, timeShift);
		local _ChiTorpedo_BUFF																= ConRO:Aura(ids.Mw_Buff.ChiTorpedo, timeShift);	
	local _RenewingMist_RDY																= ConRO:AbilityReady(ids.Mw_Ability.RenewingMist, timeShift);
	local _RisingSunKick_RDY, _RisingSunKick_CD, _RisingSunKick_MaxCD					= ConRO:AbilityReady(ids.Mw_Ability.RisingSunKick, timeShift);
	local _Roll_RDY																		= ConRO:AbilityReady(ids.Mw_Ability.Roll, timeShift);
	local _SummonJadeSerpentStatue_RDY													= ConRO:AbilityReady(ids.Mw_Talent.SummonJadeSerpentStatue, timeShift);
	local _TigerPalm_RDY 																= ConRO:AbilityReady(ids.Mw_Ability.TigerPalm, timeShift);
		local _TeachingsoftheMonastery_BUFF, _TeachingsoftheMonastery_COUNT					= ConRO:Aura(ids.Mw_Buff.TeachingsoftheMonastery, timeShift);
	local _TigersLust_RDY																= ConRO:AbilityReady(ids.Mw_Talent.TigersLust, timeShift);

	local _BonedustBrew_RDY																= ConRO:AbilityReady(ids.Covenant_Ability.BonedustBrew, timeShift);
		local _BonedustBrew_BUFF															= ConRO:Aura(ids.Covenant_Buff.BonedustBrew, timeShift);
	local _FaelineStomp_RDY																= ConRO:AbilityReady(ids.Covenant_Ability.FaelineStomp, timeShift);
		local _FaelineStomp_BUFF															= ConRO:Aura(ids.Covenant_Buff.FaelineStomp, timeShift);
	local _FallenOrder_RDY																= ConRO:AbilityReady(ids.Covenant_Ability.FallenOrder, timeShift);
		local _FallenOrder_BUFF																= ConRO:Aura(ids.Covenant_Buff.FallenOrder, timeShift);
	local _WeaponsofOrder_RDY															= ConRO:AbilityReady(ids.Covenant_Ability.WeaponsofOrder, timeShift);
		local _WeaponsofOrder_BUFF															= ConRO:Aura(ids.Covenant_Buff.WeaponsofOrder, timeShift);
		
--Conditions	
	local _is_Enemy 																	= ConRO:TarHostile();
	local _enemies_in_melee, _target_in_melee											= ConRO:Targets("Melee");
	
	local _Statue_name = 'Jade Serpent Statue';
	local _JadeSerpentStatue_ACTIVE = false;
	if tChosen[ids.Mw_Talent.SummonJadeSerpentStatue] then
		for slot = 1, 2 do
			local found, name, _, _, texture = GetTotemInfo(slot)
			if found and name == _Statue_name then
				_JadeSerpentStatue_ACTIVE = true;
			end
		end
	end
	
--Indicators
	ConRO:AbilityPurge(ids.Racial.ArcaneTorrent, _ArcaneTorrent_RDY and _target_in_melee and ConRO:Purgable());
	ConRO:AbilityMovement(ids.Mw_Ability.Roll, _Roll_RDY and not tChosen[ids.Mw_Talent.ChiTorpedo]);
	ConRO:AbilityMovement(ids.Mw_Talent.ChiTorpedo, _ChiTorpedo_RDY and not _ChiTorpedo_BUFF);
	ConRO:AbilityMovement(ids.Mw_Talent.TigersLust, _TigersLust_RDY);

	ConRO:AbilityRaidBuffs(ids.Mw_Talent.SummonJadeSerpentStatue, _SummonJadeSerpentStatue_RDY and not _JadeSerpentStatue_ACTIVE);
	ConRO:AbilityRaidBuffs(ids.Mw_Ability.RenewingMist, _RenewingMist_RDY and not ConRO:OneBuff(ids.Mw_Buff.RenewingMist));
	
--Rotations
	if _is_Enemy then
		if _RisingSunKick_RDY then
			return ids.Mw_Ability.RisingSunKick;
		end
		
		if _TigerPalm_RDY and (not _TeachingsoftheMonastery_BUFF or _TeachingsoftheMonastery_COUNT < 3) then
			return ids.Mw_Ability.TigerPalm;
		end
		
		if _BlackoutKick_RDY and not _RisingSunKick_RDY and _RisingSunKick_CD > _RisingSunKick_MaxCD - 6 then
			return ids.Mw_Ability.BlackoutKick;
		end
	end
return nil;
end

function ConRO.Monk.MistweaverDef(_, timeShift, currentSpell, gcd, tChosen, pvpChosen)
--Info
	local _Player_Level																	= UnitLevel("player");
	local _is_PvP																		= UnitIsPVP('player');
	local _in_combat 																	= UnitAffectingCombat('player');
	local _is_moving 																	= ConRO:PlayerSpeed();
	
--Resources	
	local _Player_Percent_Health 														= ConRO:PercentHealth('player');
	local _Mana 																		= UnitPower('player', Enum.PowerType.Mana);
	local _Mana_Max																		= UnitPowerMax('player', Enum.PowerType.Mana);

--Abilities	
	local _FortifyingBrew_RDY															= ConRO:AbilityReady(ids.Mw_Ability.FortifyingBrew, timeShift);

	local _DampenHarm_RDY																= ConRO:AbilityReady(ids.Mw_Talent.DampenHarm, timeShift);	
	local _HealingElixir_RDY															= ConRO:AbilityReady(ids.Mw_Talent.HealingElixir, timeShift);	

	local _Fleshcraft_RDY																= ConRO:AbilityReady(ids.Covenant_Ability.Fleshcraft, timeShift);
	
--Conditions


--Rotations
	if _HealingElixir_RDY and _Player_Percent_Health <= 80 then
		return ids.Mw_Talent.HealingElixir;
	end	

	if _Fleshcraft_RDY then
		return ids.Covenant_Ability.Fleshcraft;
	end
	
	if _FortifyingBrew_RDY then
		return ids.Mw_Ability.FortifyingBrew;
	end
	
	if _DampenHarm_RDY then
		return ids.Mw_Talent.DampenHarm;
	end	
	
return nil;
end

function ConRO.Monk.Windwalker(_, timeShift, currentSpell, gcd, tChosen, pvpChosen)
--Info
	local _Player_Level																	= UnitLevel("player");
	local _is_PvP																		= UnitIsPVP('player');
	local _in_combat 																	= UnitAffectingCombat('player');
	local _is_moving 																	= ConRO:PlayerSpeed();
	
--Resources	
	local _Player_Percent_Health 														= ConRO:PercentHealth('player');
	local _Player_Health 																= UnitHealth('player');
	local _Energy 																		= UnitPower('player', Enum.PowerType.Energy);
	local _Energy_Max																		= UnitPowerMax('player', Enum.PowerType.Energy);
	local _Chi 																			= UnitPower('player', Enum.PowerType.Chi);
	local _Chi_Max																		= UnitPowerMax('player', Enum.PowerType.Chi);
	
--Racials
	local _ArcaneTorrent_RDY															= ConRO:AbilityReady(ids.Racial.ArcaneTorrent, timeShift);

--Abilities
	local _BlackoutKick_RDY 															= ConRO:AbilityReady(ids.Ww_Ability.BlackoutKick, timeShift);
		local _BlackoutKick_BUFF 															= ConRO:Aura(ids.Ww_Buff.BlackoutKick, timeShift);
	local _CracklingJadeLightning_RDY													= ConRO:AbilityReady(ids.Ww_Ability.CracklingJadeLightning, timeShift);
		local _CracklingJadeLightning_RANGE 												= ConRO:IsSpellInRange(ids.Ww_Ability.CracklingJadeLightning);		
	local _ExpelHarm_RDY	 															= ConRO:AbilityReady(ids.Ww_Ability.ExpelHarm, timeShift);
	local _FistsofFury_RDY, _FistsofFury_CD												= ConRO:AbilityReady(ids.Ww_Ability.FistsofFury, timeShift);
		local _FistsofFury_RANGE 															= ConRO:IsSpellInRange(ids.Ww_Ability.FistsofFury);	
	local _FlyingSerpentKick_RDY														= ConRO:AbilityReady(ids.Ww_Ability.FlyingSerpentKick, timeShift);
	local _InvokeXuentheWhiteTiger_RDY 													= ConRO:AbilityReady(ids.Ww_Ability.InvokeXuentheWhiteTiger, timeShift);
	local _RisingSunKick_RDY, _RisingSunKick_CD											= ConRO:AbilityReady(ids.Ww_Ability.RisingSunKick, timeShift);
	local _Roll_RDY																		= ConRO:AbilityReady(ids.Ww_Ability.Roll, timeShift);
	local _SpearHandStrike_RDY 															= ConRO:AbilityReady(ids.Ww_Ability.SpearHandStrike, timeShift);
	local _SpinningCraneKick_RDY 														= ConRO:AbilityReady(ids.Ww_Ability.SpinningCraneKick, timeShift);
		local _DanceofChiJi_BUFF 															= ConRO:Aura(ids.Ww_Buff.DanceofChiJi, timeShift);		
		local _MarkoftheCrane_DEBUFF														= ConRO:TargetAura(ids.Ww_Debuff.MarkoftheCrane, timeShift);
	local _StormEarthandFire_RDY														= ConRO:AbilityReady(ids.Ww_Ability.StormEarthandFire, timeShift);
		local _StormEarthandFire_BUFF														= ConRO:Aura(ids.Ww_Buff.StormEarthandFire, timeShift);
		local _StormEarthandFire_CHARGES, _StormEarthandFire_MaxCHARGES						= ConRO:SpellCharges(ids.Ww_Ability.StormEarthandFire);	
	local _TigerPalm_RDY					 											= ConRO:AbilityReady(ids.Ww_Ability.TigerPalm, timeShift);
	local _TouchofDeath_RDY 															= ConRO:AbilityReady(ids.Ww_Ability.TouchofDeath, timeShift);
		local _TouchofDeath_DEBUFF															= ConRO:TargetAura(ids.Ww_Debuff.TouchofDeath, timeShift);
	
	local _ChiTorpedo_RDY																= ConRO:AbilityReady(ids.Ww_Talent.ChiTorpedo, timeShift);
		local _ChiTorpedo_BUFF																= ConRO:Aura(ids.Ww_Buff.ChiTorpedo, timeShift);	
	local _TigersLust_RDY																= ConRO:AbilityReady(ids.Ww_Talent.TigersLust, timeShift);	
	local _EnergizingElixir_RDY 														= ConRO:AbilityReady(ids.Ww_Talent.EnergizingElixir, timeShift);	
	local _WhirlingDragonPunch_RDY, _WhirlingDragonPunch_CD 												= ConRO:AbilityReady(ids.Ww_Talent.WhirlingDragonPunch, timeShift);
	local _ChiWave_RDY 																	= ConRO:AbilityReady(ids.Ww_Talent.ChiWave, timeShift);
	local _Serenity_RDY 																= ConRO:AbilityReady(ids.Ww_Talent.Serenity, timeShift);
		local _Serenity_BUFF, _, _Serenity_DUR												= ConRO:Aura(ids.Ww_Buff.Serenity, timeShift);
	local _RushingJadeWind_RDY 															= ConRO:AbilityReady(ids.Ww_Talent.RushingJadeWind, timeShift);
	local _ChiBurst_RDY 																= ConRO:AbilityReady(ids.Ww_Talent.ChiBurst, timeShift);
	local _FistoftheWhiteTiger_RDY 														= ConRO:AbilityReady(ids.Ww_Talent.FistoftheWhiteTiger, timeShift);
	
	local _BonedustBrew_RDY																= ConRO:AbilityReady(ids.Covenant_Ability.BonedustBrew, timeShift);
		local _BonedustBrew_BUFF															= ConRO:Aura(ids.Covenant_Buff.BonedustBrew, timeShift);
	local _FaelineStomp_RDY																= ConRO:AbilityReady(ids.Covenant_Ability.FaelineStomp, timeShift);
		local _FaelineStomp_BUFF															= ConRO:Aura(ids.Covenant_Buff.FaelineStomp, timeShift);
	local _FallenOrder_RDY																= ConRO:AbilityReady(ids.Covenant_Ability.FallenOrder, timeShift);
		local _FallenOrder_BUFF																= ConRO:Aura(ids.Covenant_Buff.FallenOrder, timeShift);
	local _WeaponsofOrder_RDY															= ConRO:AbilityReady(ids.Covenant_Ability.WeaponsofOrder, timeShift);
		local _WeaponsofOrder_BUFF															= ConRO:Aura(ids.Covenant_Buff.WeaponsofOrder, timeShift);
		
--Conditions
	local _enemies_in_melee, _target_in_melee											= ConRO:Targets("Melee");
	local _Target_Percent_Health  														= ConRO:PercentHealth('target');
	local _Target_Health 																= UnitHealth('target');
	
--Indicators
	ConRO:AbilityInterrupt(ids.Ww_Ability.SpearHandStrike, _SpearHandStrike_RDY and ConRO:Interrupt());
	ConRO:AbilityPurge(ids.Racial.ArcaneTorrent, _ArcaneTorrent_RDY and _target_in_melee and ConRO:Purgable());
	ConRO:AbilityMovement(ids.Ww_Ability.Roll, _Roll_RDY and not tChosen[ids.Ww_Talent.ChiTorpedo]);
	ConRO:AbilityMovement(ids.Ww_Talent.ChiTorpedo, _ChiTorpedo_RDY and not _ChiTorpedo_BUFF);
	ConRO:AbilityMovement(ids.Ww_Talent.TigersLust, _TigersLust_RDY);
	ConRO:AbilityMovement(ids.Ww_Ability.FlyingSerpentKick, _FlyingSerpentKick_RDY);
	
	ConRO:AbilityBurst(ids.Ww_Ability.TouchofDeath, _TouchofDeath_RDY and ConRO_BurstButton:IsVisible());
	ConRO:AbilityBurst(ids.Ww_Ability.InvokeXuentheWhiteTiger, _InvokeXuentheWhiteTiger_RDY and ConRO_BurstButton:IsVisible());
	ConRO:AbilityBurst(ids.Ww_Ability.StormEarthandFire, _StormEarthandFire_RDY and not _StormEarthandFire_BUFF and not tChosen[ids.Ww_Talent.Serenity] and ConRO_BurstButton:IsVisible());
	ConRO:AbilityBurst(ids.Ww_Talent.Serenity, _Serenity_RDY and _FistsofFury_CD == 0 and ConRO_BurstButton:IsVisible());
	ConRO:AbilityBurst(ids.Covenant_Ability.WeaponsofOrder, _WeaponsofOrder_RDY and ConRO_BurstButton:IsVisible());
	ConRO:AbilityBurst(ids.Covenant_Ability.FallenOrder, _FallenOrder_RDY and ConRO_BurstButton:IsVisible());
	
--Rotations
	if not _in_combat then
		if _ExpelHarm_RDY and _Chi <= 4 then
			return ids.Ww_Ability.ExpelHarm;
		end
		
		if _ChiWave_RDY and _CracklingJadeLightning_RANGE then
			return ids.Ww_Talent.ChiWave;
		end

		if _ChiBurst_RDY and _CracklingJadeLightning_RANGE and _Chi <= 4 and currentSpell ~= ids.Ww_Talent.ChiBurst then
			return ids.Ww_Talent.ChiBurst;
		end
	elseif _Serenity_BUFF then
		if _RisingSunKick_RDY and ConRO.lastSpellId ~= ids.Ww_Ability.RisingSunKick then
			return ids.Ww_Ability.RisingSunKick;
		end
		
		if _FistsofFury_RDY and _Serenity_DUR >= 9 then
			return ids.Ww_Ability.FistsofFury;
		end
		
		if _BlackoutKick_RDY and ConRO.lastSpellId ~= ids.Ww_Ability.BlackoutKick then
			return ids.Ww_Ability.BlackoutKick;
		end	

		if _FistsofFury_RDY then
			return ids.Ww_Ability.FistsofFury;
		end
		
		if tChosen[ids.Ww_Talent.FistoftheWhiteTiger] then
			if _FistoftheWhiteTiger_RDY then
				return ids.Ww_Talent.FistoftheWhiteTiger;
			end
		else
			if _SpinningCraneKick_RDY then
				return ids.Ww_Ability.SpinningCraneKick;
			end		
		end
	else
		if _InvokeXuentheWhiteTiger_RDY and ConRO_FullButton:IsVisible() then
			return ids.Ww_Ability.InvokeXuentheWhiteTiger;
		end	
	
		if _WeaponsofOrder_RDY and ConRO_FullButton:IsVisible() then
			return ids.Covenant_Ability.WeaponsofOrder;
		end

		if _FallenOrder_RDY and ConRO_FullButton:IsVisible() then
			return ids.Covenant_Ability.FallenOrder;
		end
		
		if _TouchofDeath_RDY and ConRO_FullButton:IsVisible() then
			return ids.Ww_Ability.TouchofDeath;
		end	
	
		if _BonedustBrew_RDY and _Energy >= _Energy_Max - 15 and _Chi >= 4 then
			return ids.Covenant_Ability.BonedustBrew;
		end	

		if _StormEarthandFire_RDY and not _StormEarthandFire_BUFF and not tChosen[ids.Ww_Talent.Serenity] and ConRO_FullButton:IsVisible() then
			return ids.Ww_Ability.StormEarthandFire;
		end
		
		if _Serenity_RDY and _FistsofFury_CD == 0 and ConRO_FullButton:IsVisible() then
			return ids.Ww_Talent.Serenity;
		end
		
		if _ExpelHarm_RDY and _Chi <= 4 and _Energy >= _Energy_Max - 15 then
			return ids.Ww_Ability.ExpelHarm;
		end

		if _FistoftheWhiteTiger_RDY and _Chi < 3 and _Energy >= _Energy_Max - 15 then
			return ids.Ww_Talent.FistoftheWhiteTiger;
		end

		if _TigerPalm_RDY and _Chi < 4 and _Energy >= _Energy_Max - 15 and ConRO.lastSpellId ~= ids.Ww_Ability.TigerPalm then
			return ids.Ww_Ability.TigerPalm;
		end	

		if _WhirlingDragonPunch_RDY and _FistsofFury_CD > 0 and _RisingSunKick_CD > 0 then
			return ids.Ww_Talent.WhirlingDragonPunch;
		end
	
		if _SpinningCraneKick_RDY and _FistsofFury_RANGE and _FistsofFury_CD > 2 and _DanceofChiJi_BUFF and ((ConRO_AutoButton:IsVisible() and _enemies_in_melee >= 3) or ConRO_AoEButton:IsVisible()) then
			return ids.Ww_Ability.SpinningCraneKick;
		end

		if _FistsofFury_RDY and _FistsofFury_RANGE and currentSpell ~= ids.Ww_Ability.FistsofFury then
			return ids.Ww_Ability.FistsofFury;
		end
		
		if _RisingSunKick_RDY and ((ConRO_AutoButton:IsVisible() and _enemies_in_melee <= 1) or ConRO_SingleButton:IsVisible()) then
			return ids.Ww_Ability.RisingSunKick;
		end
		
		if _FaelineStomp_RDY then
			return ids.Covenant_Ability.FaelineStomp;
		end
		
		if _RushingJadeWind_RDY and _FistsofFury_RANGE and ((ConRO_AutoButton:IsVisible() and _enemies_in_melee >= 2) or ConRO_AoEButton:IsVisible()) then
			return ids.Ww_Ability.RushingJadeWind;
		end

		if _RisingSunKick_RDY and (tChosen[ids.Ww_Talent.WhirlingDragonPunch] and not _WhirlingDragonPunch_RDY and _WhirlingDragonPunch_CD < 3) then
			return ids.Ww_Ability.RisingSunKick;
		end

		if _ExpelHarm_RDY and _Chi <= 4 then
			return ids.Ww_Ability.ExpelHarm;
		end

		if _ChiBurst_RDY and _CracklingJadeLightning_RANGE and _Chi <= 4 and currentSpell ~= ids.Ww_Talent.ChiBurst then
			return ids.Ww_Talent.ChiBurst;
		end
		
		if _SpinningCraneKick_RDY and _FistsofFury_RANGE and _FistsofFury_CD > 2 and ((ConRO_AutoButton:IsVisible() and _enemies_in_melee >= 3) or ConRO_AoEButton:IsVisible()) then
			return ids.Ww_Ability.SpinningCraneKick;
		end

		if _FistoftheWhiteTiger_RDY then
			return ids.Ww_Talent.FistoftheWhiteTiger;
		end

		if _SpinningCraneKick_RDY and _FistsofFury_RANGE and _FistsofFury_CD > 2 and _DanceofChiJi_BUFF  then
			return ids.Ww_Ability.SpinningCraneKick;
		end

		if _BlackoutKick_RDY and ConRO.lastSpellId ~= ids.Ww_Ability.BlackoutKick and ((ConRO_AutoButton:IsVisible() and _enemies_in_melee <= 1) or ConRO_SingleButton:IsVisible() or not _MarkoftheCrane_DEBUFF) then
			return ids.Ww_Ability.BlackoutKick;
		end	
		
		if _ChiWave_RDY and _CracklingJadeLightning_RANGE then
			return ids.Ww_Talent.ChiWave;
		end
		
		if _ExpelHarm_RDY and _target_in_melee then
			return ids.Ww_Ability.ExpelHarm;
		end	
		
		if _EnergizingElixir_RDY and _Chi < 4 and _Energy <= 50 then
			return ids.Ww_Talent.EnergizingElixir;
		end
		
		if _TigerPalm_RDY and ConRO.lastSpellId ~= ids.Ww_Ability.TigerPalm then
			return ids.Ww_Ability.TigerPalm;
		end
	end
return nil;
end

function ConRO.Monk.WindwalkerDef(_, timeShift, currentSpell, gcd, tChosen, pvpChosen)
--Info
	local _Player_Level																	= UnitLevel("player");
	local _is_PvP																		= UnitIsPVP('player');
	local _in_combat 																	= UnitAffectingCombat('player');
	local _is_moving 																	= ConRO:PlayerSpeed();
	
--Resources	
	local _Player_Percent_Health 														= ConRO:PercentHealth('player');
	local _Energy 																		= UnitPower('player', Enum.PowerType.Energy);
	local _Energy_Max																	= UnitPowerMax('player', Enum.PowerType.Energy);
	local _Chi 																			= UnitPower('player', Enum.PowerType.Chi);
	local _Chi_Max																		= UnitPowerMax('player', Enum.PowerType.Chi);
	
--Abilities
	local _ExpelHarm_RDY																= ConRO:AbilityReady(ids.Ww_Ability.ExpelHarm, timeShift);	
	local _FortifyingBrew_RDY															= ConRO:AbilityReady(ids.Ww_Ability.FortifyingBrew, timeShift);
	local _TouchofKarma_RDY 															= ConRO:AbilityReady(ids.Ww_Ability.TouchofKarma, timeShift);
	
	local _DampenHarm_RDY																= ConRO:AbilityReady(ids.Ww_Talent.DampenHarm, timeShift);	

	local _Fleshcraft_RDY																= ConRO:AbilityReady(ids.Covenant_Ability.Fleshcraft, timeShift);
	
--Conditions
	
--Rotations	
	if _ExpelHarm_RDY and _Player_Percent_Health <= 50 then
		return ids.Ww_Ability.ExpelHarm;
	end	
	
	if _Fleshcraft_RDY then
		return ids.Covenant_Ability.Fleshcraft;
	end

	if _TouchofKarma_RDY then
		return ids.Ww_Ability.TouchofKarma;
	end
	
	if _DampenHarm_RDY then
		return ids.Ww_Talent.DampenHarm;
	end
	
	if _FortifyingBrew_RDY then
		return ids.Ww_Ability.FortifyingBrew;
	end	
	
return nil;
end
